class
	AST_GCC_ATTRIBUTE_SPECIFIER

inherit
	AST_NODE

create
	make_from_antlr,
	make_copy

feature {NONE}

	make_from_antlr (node: ANTLR_AST_NODE; a_parent: AST_NODE)
		require
			node /= Void and then node.type = C_kw_attribute
		do
			parent := a_parent

			attributes := create {TWO_WAY_LIST [AST_GCC_ATTRIBUTE]}.make
			across node.children as c loop
				attributes.extend (create {AST_GCC_ATTRIBUTE}.make_from_antlr (c.item, Current))
			end
		end

feature {ANY}

	attributes: LIST [AST_GCC_ATTRIBUTE]

	find_attribute (a_identifier: STRING_8): AST_GCC_ATTRIBUTE
		require
			a_identifier /= Void
		do
			across
				attributes as c
			until
				Result /= Void
			loop
				if c.item.identifier.is_equal (a_identifier) then
					Result := c.item
				end
			end
		end

	merge (a_other: AST_GCC_ATTRIBUTE_SPECIFIER)
		require
			a_other /= Void
		do
			across a_other.attributes as c loop
				attributes.extend (c.item.ast_twin)
				attributes.last.parent := Current
			end
		end

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_attribute_specifier (Current)
			if visit_children then
				visit_list (attributes, v)
			end
			v.end_visit_attribute_specifier (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (other: like Current)
		do
			attributes := create {TWO_WAY_LIST [AST_GCC_ATTRIBUTE]}.make
			across other.attributes as c loop
				attributes.extend (c.item.ast_twin)
				attributes.last.parent := Current
			end
		end

invariant
	attributes /= Void and then not attributes.is_empty

end
