class
	AST_CHARACTER_CONSTANT

inherit
	AST_EXPRESSION

create
	make,
	make_from_antlr,
	make_copy

feature {NONE}

	make (a_value: STRING)
		require
			a_value /= Void
		do
			value := a_value
		ensure
			value = a_value
		end

	make_from_antlr (node: ANTLR_AST_NODE; init_parent: AST_NODE)
		require
			node /= Void and then node.type = Ast_character_constant
		do
			parent := init_parent
			value := node.children.first.token_text
			-- remove starting and trailing quotes:
			value.remove_head (1)
			value.remove_tail (1)
		end

feature {ANY}

	value: STRING

	is_eiffel_character: BOOLEAN assign set_is_eiffel_character

	set_is_eiffel_character (a_is_eiffel_character: BOOLEAN)
		do
			is_eiffel_character := a_is_eiffel_character
		end

	type_binding: AST_TYPE
		once ("OBJECT")
			Result := create {AST_BASIC_TYPE}.make (Ast_bt_int)
		end

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_character_constant (Current)
			if visit_children then
				-- no children...
			end
			v.end_visit_character_constant (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (other: like Current)
		do
			value := other.value.twin
			is_eiffel_character := other.is_eiffel_character
		end

invariant
	value /= Void and then not value.is_empty

end
