class
	AST_EIFFEL_EXPRESSION

inherit
	AST_EXPRESSION
	AST_UTILITIES

create
	make,
	make_mixed,
	make_copy

feature {NONE}

	make (a_code: STRING; a_type_binding: AST_TYPE)
		require
			a_code /= Void
			a_type_binding /= Void
		do
			mixed := create {TWO_WAY_LIST [ANY]}.make
			mixed.extend (a_code)
			type_binding := a_type_binding
		end

	make_mixed (a_mixed: ARRAY [ANY]; a_type_binding: AST_TYPE)
		require
			a_mixed /= Void and then not a_mixed.is_empty and then across a_mixed as c all
					attached {STRING} c.item or (attached {AST_NODE} c.item as tmp and then tmp.parent = Void)
				end
			a_type_binding /= Void
		do
			mixed := create {TWO_WAY_LIST [ANY]}.make
			across a_mixed as c loop
				if attached {AST_NODE}c.item as node then
					node.parent := Current
				end
				mixed.extend (c.item)
			end
			type_binding := a_type_binding
		end

feature {ANY}

	mixed: LIST [ANY]

	is_string (a_index: INTEGER_32; a_string: STRING_8): BOOLEAN
		require
			a_index >= 1 and a_index <= mixed.count
			a_string /= Void
		do
			Result := attached {STRING_8} mixed.i_th (a_index) as tmp and then tmp.is_equal (a_string)
		end

	type_binding: AST_TYPE

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_eiffel_expression (Current)
			if visit_children then
				across mixed.twin as c loop
					if attached {AST_NODE} c.item as node then
						node.accept (v)
					end
				end
			end
			v.end_visit_eiffel_expression (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (other: like Current)
		do
			mixed := create {TWO_WAY_LIST [ANY]}.make
			across other.mixed as c loop
				if attached {AST_NODE} c.item as tmp then
					mixed.extend (tmp.ast_twin)
					({AST_NODE} #? mixed.last).parent := Current
				else
					mixed.extend (c.item.twin)
				end
			end
			type_binding := other.type_binding
		end

invariant
	mixed /= Void and then not mixed.is_empty and then across mixed as c all attached {STRING_8} c.item or attached {AST_NODE} c.item end

end
