class
	AST_IF_STATEMENT

inherit
	AST_STATEMENT

create
	make_if,
	make_if_short,
	make_copy

feature {NONE}

	make_if_short (a_condition: AST_EXPRESSION; a_then: AST_STATEMENT)
		require
			a_condition /= Void and then a_condition.parent = Void
			a_then /= Void and then a_then.parent = Void
		do
			condition := a_condition
			condition.parent := Current

			create then_statements.make_with_statement (a_then)
			then_statements.parent := Current
		end

	make_if (a_condition: AST_EXPRESSION; a_then: AST_COMPOUND_STATEMENT)
		require
			a_condition /= Void and then a_condition.parent = Void
			a_then /= Void and then a_then.parent = Void
		do
			condition := a_condition
			condition.parent := Current

			then_statements := a_then
			then_statements.parent := Current
		end

feature {ANY}

	condition: AST_EXPRESSION

	then_statements: AST_COMPOUND_STATEMENT

	is_skip_block: BOOLEAN assign set_is_skip_block

	set_is_skip_block (a_is_skip_block: BOOLEAN)
		do
			is_skip_block := a_is_skip_block
		end

feature {ANY} -- C2Eif data

	requires_split: BOOLEAN assign set_requires_split

	set_requires_split (a_requires_split: BOOLEAN)
		do
			requires_split := a_requires_split
		end

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_if_statement (Current)
			if visit_children then
				visit_node (condition, v)
				visit_node (then_statements, v)
			end
			v.end_visit_if_statement (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (other: like Current)
		do
			condition := other.condition.ast_twin
			condition.parent := Current
			then_statements := other.then_statements.ast_twin
			then_statements.parent := Current
			is_skip_block := other.is_skip_block
			requires_split := other.requires_split
		end

invariant
	condition /= Void
	then_statements /= Void

end
