class
	AST_JUMP_STATEMENT

inherit
	AST_STATEMENT

create
	make_from_antlr,
	make_copy

feature {NONE}

	make_from_antlr (node: ANTLR_AST_NODE; init_parent: AST_NODE)
		require
			node /= Void and then node.type = Ast_jump_statement
		do
			parent := init_parent

			type := node.children.first.type
			if type = C_kw_goto then
				goto_identifier := node.children.i_th (2).token_text
			elseif type = C_kw_return and node.children.count = 3 then
				return_expression := process_expression (node.children.i_th (2), Current)
			end
		end

feature {ANY}

	type: INTEGER

	goto_identifier: STRING

	return_expression: AST_EXPRESSION

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_jump_statement (Current)
			if visit_children then
				visit_node (return_expression, v)
			end
			v.end_visit_jump_statement (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (other: like Current)
		do
			type := other.type
			if other.goto_identifier /= Void then
				goto_identifier := other.goto_identifier.twin
			end
			if other.return_expression /= Void then
				return_expression := other.return_expression.ast_twin
				return_expression.parent := Current
			end
		end

invariant
	type = C_kw_goto or type = C_kw_continue or type = C_kw_break or type = C_kw_return;
	(type = C_kw_goto) = (goto_identifier /= Void)
	return_expression /= Void implies type = C_kw_return

end
