class
	OO_REGULAR_CLASS

inherit
	OO_CLASS

create
	make

feature {NONE}

	make (a_name: STRING_8)
		require
			a_name /= Void and then not a_name.is_empty
		do
			name := a_name
			features := create {TWO_WAY_LIST [OO_FEATURE]}.make
			create superclasses.make
		end

feature {ANY}

	name: STRING_8

	set_name (a_name: STRING_8)
		do
			name := a_name
		end

	is_system_source: BOOLEAN
		do
			Result := not features.is_empty and then features.first.node.source_info.is_system_source
		end

	features: LIST [OO_FEATURE]

	add_feature (a_feature: OO_FEATURE)
		require
			a_feature /= Void
		do
			features.extend (a_feature)
		end

feature {ANY}

	attributes: LIST [OO_FEATURE]
		do
			Result := create {SORTED_TWO_WAY_LIST [OO_FEATURE]}.make
			across features as c loop
				if attached {AST_VARIABLE_DECLARATION} c.item.node then
					Result.extend (c.item)
				end
			end
		end

	routines: LIST [OO_FEATURE]
		do
			Result := create {SORTED_TWO_WAY_LIST [OO_FEATURE]}.make
			across features as c loop
				if attached {AST_FUNCTION_DECLARATION} c.item.node then
					Result.extend (c.item)
				end
			end
		end

invariant
	features /= Void

end
