class
	OO_TRANSFORMER

inherit
	TRANSFORMATION_STEP
	C2EIFFEL_GUI_INSTANCE
	NAME_UTILITIES

feature {ANY} -- TRANSFORMATION_STEP

	process_impl: BOOLEAN
		local
--			oo_dialog: OO_DIALOG
		do
			transformer.oo_cluster := create_cluster

--			if instance.instance /= Void then
--				create oo_dialog.make (transformer.oo_cluster)
--				oo_dialog.show_modal_to_window (instance.instance)
--			end
			Result := True
		end

	description: STRING
		do
			Result := "Creating O-O model"
		end

feature {NONE}

	create_cluster: OO_CLUSTER
		local
			l_base_name: STRING_8
		do
			l_base_name := eiffel_class_name (transformer.tree.source_file_name) -- e.g. "XEYES"
			create Result.make (l_base_name.as_lower)

			across transformer.tree.declarations as c loop
				if attached {AST_EIFFEL_FEATURE} c.item as tmp then
					add_feature (Result, tmp)
				elseif attached {AST_STRUCT_DECLARATION} c.item as tmp then
					add_data_class (Result, tmp)
				elseif attached {AST_ENUM_DECLARATION} c.item as tmp then
					add_constant_class (Result, tmp)
				else
					(create {EXCEPTIONS}).raise (c.item.generator)
				end
			end
		end

	add_feature (a_oo_cluster: OO_CLUSTER; a_node: AST_EIFFEL_FEATURE)
		local
			l_class_name: STRING_8
			l_path: STRING_8
			l_class: OO_REGULAR_CLASS
		do
			if a_node.source_info.is_project_source then
				l_class_name := "P_"
			else
				l_class_name := "S_"
				l_path := "system"
			end
			l_class_name.append (eiffel_class_name (a_node.source_info.source_file))

			l_class ?= a_oo_cluster.get_class (l_class_name)
			if l_class = Void then
				create l_class.make (l_class_name)
				a_oo_cluster.add_class (l_path, l_class)
			end
			l_class.add_feature (create {OO_FEATURE}.make (l_class, a_node))
		end

	add_data_class (a_oo_cluster: OO_CLUSTER; a_node: AST_STRUCT_DECLARATION)
		local
			l_class_name: STRING_8
			l_path: STRING_8
		do
			if a_node.source_info.is_project_source then
				l_class_name := "PD_"
				l_path := "data"
			else
				l_class_name := "SD_"
				l_path := "system/data"
			end
			l_class_name.append (eiffel_class_name (a_node.identifier))

			a_node.identifier.make_from_string (l_class_name)
			a_oo_cluster.add_class (l_path, create {OO_DATA_CLASS}.make (a_node))
		end

	add_constant_class (a_oo_cluster: OO_CLUSTER; a_node: AST_ENUM_DECLARATION)
		local
			l_class_name: STRING_8
			l_path: STRING_8
		do
			if a_node.source_info.is_project_source then
				l_class_name := "PC_"
				l_path := "constants"
			else
				l_class_name := "SC_"
				l_path := "system/constants"
			end
			l_class_name.append (eiffel_class_name (a_node.identifier))

			a_node.identifier.make_from_string (l_class_name)
			a_oo_cluster.add_class (l_path, create {OO_CONSTANT_CLASS}.make (a_node))
		end

end
