class
	POINTER_TRANSFORMER

inherit
	TRANSFORMATION_STEP
	AST_DEFAULT_VISITOR
		redefine
			end_visit_generic_expression
		end

feature {ANY} -- TRANSFORMATION_STEP

	process_impl: BOOLEAN
		do
			transformer.tree.accept (Current)
			Result := True
		end

	description: STRING_8
		do
			Result := "Adapting pointer semantics"
		end

feature {ANY} -- AST_DEFAULT_VISITOR

	end_visit_generic_expression (a_node: AST_GENERIC_EXPRESSION)
		local
			l_expr: AST_EXPRESSION
		do
			if
				a_node.is_equality_expression and then
				attached {AST_EXPRESSION} a_node.left.non_cast_expression as left_expr and then
				attached {AST_EXPRESSION} a_node.right.non_cast_expression as right_expr and then
				attached {BOOLEAN} (attached {AST_POINTER_TYPE} left_expr.type_binding or attached {AST_ARRAY_TYPE} left_expr.type_binding) as left_is_pointer and then
				attached {BOOLEAN} (attached {AST_POINTER_TYPE} right_expr.type_binding or attached {AST_ARRAY_TYPE} right_expr.type_binding) as right_is_pointer and then
				attached {BOOLEAN} (attached {AST_DECIMAL_CONSTANT} left_expr as ldc and then ldc.value.is_equal ("0")) as left_is_void and then
				attached {BOOLEAN} (attached {AST_DECIMAL_CONSTANT} right_expr as rdc and then rdc.value.is_equal ("0")) as right_is_void
			then
				-- `ptr1 == ptr2'  ->  `ptr1.is_equal (ptr2)'
				if left_is_pointer and right_is_pointer then
					l_expr := create {AST_EIFFEL_EXPRESSION}.make_mixed (
						<<
							create {AST_PARENTHESIZED_EXPRESSION}.make (left_expr.ast_twin),
							".is_equal (",
							right_expr.ast_twin,
							")"
						>>, a_node.type_binding)
					if a_node.type = C_op_not_equal then
						l_expr := create {AST_UNARY_EXPRESSION}.make (C_op_not, l_expr)
					end
					replace_node (a_node, l_expr)

				-- `p == 0' -> `p.is_void'
				elseif (left_is_pointer and right_is_void) or (left_is_void and right_is_pointer) then
					if left_is_pointer then
						l_expr := left_expr
					else
						l_expr := right_expr
					end
					l_expr := create {AST_EIFFEL_EXPRESSION}.make_mixed (
						<<
							create {AST_PARENTHESIZED_EXPRESSION}.make (l_expr.ast_twin),
							".is_void"
						>>, a_node.type_binding)
					if a_node.type = C_op_not_equal then
						l_expr := create {AST_UNARY_EXPRESSION}.make (C_op_not, l_expr)
					end
					replace_node (a_node, l_expr)
				end
			end
		end

end
