deferred class
	TRANSFORMATION_STEP

inherit
	AST_UTILITIES
	ANTLR_AST_TYPE_CONSTANTS
	VIEW_INTERFACE

feature {ANY}

	frozen process (a_transformer: CODE_TRANSFORMER): BOOLEAN
		require
			a_transformer /= Void
		do
			transformer := a_transformer
			Result := process_impl
		end

feature {ANY}

	process_impl: BOOLEAN
		deferred
		end

	description: STRING
		deferred
		end

	emit_tree (tree: EV_TREE)
		do
			transformer.tree.accept (create {AST_TREE_PRINTER}.make (tree))
		end

	emit_source (text: EV_TEXT)
		do
			text.set_text (transformer.tree.c_code)
		end

feature {NONE} -- data and utilities for subclasses

	transformer: CODE_TRANSFORMER

end
