class
	OO_DIALOG

inherit
	EV_DIALOG

create
	make

feature {NONE}

	make (a_oo_cluster: OO_CLUSTER)
		local
			l_button_box: EV_HORIZONTAL_BOX
			l_left_split_area: EV_VERTICAL_SPLIT_AREA
			l_main_split_area: EV_HORIZONTAL_SPLIT_AREA
			l_main_box: EV_VERTICAL_BOX
			l_cluster_item: EV_TREE_ITEM
		do
			make_with_title ("O-O Reengineering; Reviewing and Adaption")

			create class_overview
			class_overview.select_actions.extend (agent class_overview_selection_changed)
			class_overview.key_press_actions.extend (agent class_overview_key_pressed)

			create feature_overview
			feature_overview.select_actions.extend (agent feature_overview_selection_changed)
			feature_overview.key_press_actions.extend (agent feature_overview_key_pressed)

			create class_source
			class_source.disable_edit

			create l_button_box
			l_button_box.extend (create {EV_HORIZONTAL_BOX}) -- spacer to have the buttons centered
			l_button_box.extend (create {EV_BUTTON}.make_with_text_and_action ("Ok", agent ok_pressed))
			l_button_box.disable_item_expand (l_button_box.i_th (l_button_box.count))
			l_button_box.extend (create {EV_HORIZONTAL_BOX}) -- spacer to have the buttons centered

			create l_left_split_area
			l_left_split_area.extend (class_overview)
			l_left_split_area.extend (feature_overview)
			l_left_split_area.set_minimum_size (100, 400)
			l_left_split_area.set_split_position (300)

			create l_main_split_area
			l_main_split_area.extend (l_left_split_area)
			l_main_split_area.extend (class_source)
			l_main_split_area.set_minimum_size (400, 200)
			l_main_split_area.set_split_position (200)

			create l_main_box
			l_main_box.set_padding (3)
			l_main_box.extend (l_main_split_area)
			l_main_box.extend (l_button_box)
			l_main_box.disable_item_expand (l_main_box.i_th (l_main_box.count))

			extend (l_main_box)
			set_size (800, 600)

			create l_cluster_item.make_with_text (a_oo_cluster.name)
			l_cluster_item.set_pixmap (cluster_pixmap)
			class_overview.extend (l_cluster_item)

			create_class_overview (l_cluster_item, a_oo_cluster)
			l_cluster_item.expand
		end

feature {NONE}

	class_overview: EV_TREE

	feature_overview: EV_LIST

	class_source: EV_TEXT

feature {NONE}

	class_overview_selection_changed
		local
			l_list_item: EV_LIST_ITEM
			l_visitor: AST_EIFFEL_CREATOR
			l_first: BOOLEAN
		do
			feature_overview.wipe_out
			class_source.set_text ("")

			if attached {OO_REGULAR_CLASS} class_overview.selected_item.data as tmp then
				create l_visitor.make
				l_visitor.omit_routine_body := True
				l_first := True
				across tmp.attributes as c loop
					create l_list_item.make_with_text (c.item.name)
					l_list_item.set_pixmap (attribute_pixmap)
					feature_overview.extend (l_list_item)

					if l_first then
						l_first := False
					else
						l_visitor.buffer.append ("%N%N")
					end
					l_visitor.buffer.append ("%T")
					c.item.node.accept (l_visitor)

					l_list_item.set_data (c.item)
				end
				across tmp.routines as c loop
					create l_list_item.make_with_text (c.item.name)
					l_list_item.set_pixmap (routine_pixmap)
					feature_overview.extend (l_list_item)

					if l_first then
						l_first := False
					else
						l_visitor.buffer.append ("%N%N")
					end
					c.item.node.accept (l_visitor)

					l_list_item.set_data (c.item)
				end
				class_source.set_text (l_visitor.buffer)
			end
		end

	class_overview_key_pressed (a_key: EV_KEY)
		local
			l_input_dialog: EV_INPUT_DIALOG
		do
			if
				a_key.code = {EV_KEY_CONSTANTS}.Key_f2 and then
				attached class_overview.selected_item as ot_selected_item and then
				attached {OO_CLASS} ot_selected_item.data as ot_selected_class
			then
				create l_input_dialog.make_with_text ("New Class Name:")
				l_input_dialog.set_title ("Change Class Name")
				l_input_dialog.set_input (ot_selected_class.name)
				l_input_dialog.ok_select_actions.extend (
						agent (ag_selected_item: EV_TREE_NODE; ag_selected_class: OO_CLASS; ag_input_dialog: EV_INPUT_DIALOG)
							do
								if not ag_input_dialog.input.is_empty then
									ag_selected_item.set_text (ag_input_dialog.input)
									ag_selected_class.set_name (ag_input_dialog.input)
								end
							end (ot_selected_item, ot_selected_class, l_input_dialog)
					)
				l_input_dialog.show_modal_to_window (Current)
			end
		end

	feature_overview_selection_changed
		local
			l_visitor: AST_EIFFEL_CREATOR
		do
			if attached {OO_FEATURE} feature_overview.selected_item.data as tmp then
				create l_visitor.make
				l_visitor.omit_routine_body := True
				tmp.node.accept (l_visitor)
				class_source.set_text (l_visitor.buffer)
			else
				class_source.set_text (feature_overview.selected_item.generating_type + "?")
			end
		end

	feature_overview_key_pressed (a_key: EV_KEY)
		local
			l_input_dialog: EV_INPUT_DIALOG
		do
			if
				a_key.code = {EV_KEY_CONSTANTS}.Key_f2 and then
				attached feature_overview.selected_item as ot_selected_item and then
				attached {OO_FEATURE} ot_selected_item.data as ot_selected_feature
			then
				create l_input_dialog.make_with_text ("New Feature Name:")
				l_input_dialog.set_title ("Change Feature Name")
				l_input_dialog.set_input (ot_selected_feature.name)
				l_input_dialog.ok_select_actions.extend (
						agent (ag_selected_item: EV_LIST_ITEM; ag_selected_feature: OO_FEATURE; ag_input_dialog: EV_INPUT_DIALOG)
							do
								if not ag_input_dialog.input.is_empty then
									ag_selected_item.set_text (ag_input_dialog.input)
									ag_selected_feature.set_name (ag_input_dialog.input)
								end
							end (ot_selected_item, ot_selected_feature, l_input_dialog)
					)
				l_input_dialog.show_modal_to_window (Current)
			end
		end

	ok_pressed
		do
			destroy
		end

feature {NONE}

	create_class_overview (a_parent_item: EV_TREE_ITEM; a_parent_directory: OO_DIRECTORY)
		require
			a_parent_item /= Void
			a_parent_directory /= Void
		local
			l_tree_item: EV_TREE_ITEM
		do
			across a_parent_directory.directories as c loop
				create l_tree_item.make_with_text (c.item.name)
				l_tree_item.set_pixmap (directory_pixmap)
				a_parent_item.extend (l_tree_item)

				create_class_overview (l_tree_item, c.item)
			end
			across a_parent_directory.classes as c loop
				create l_tree_item.make_with_text (c.item.name)
				l_tree_item.set_pixmap (class_pixmap)
				a_parent_item.extend (l_tree_item)

				l_tree_item.set_data (c.item)
			end
		end

feature {NONE}

	cluster_pixmap: EV_PIXMAP
		once ("PROCESS")
			create Result
			Result.set_with_named_file ("../resources/images/cluster.png")
		end

	class_pixmap: EV_PIXMAP
		once ("PROCESS")
			create Result
			Result.set_with_named_file ("../resources/images/class.png")
		end

	directory_pixmap: EV_PIXMAP
		once ("PROCESS")
			create Result
			Result.set_with_named_file ("../resources/images/directory.png")
		end

	attribute_pixmap: EV_PIXMAP
		once ("PROCESS")
			create Result
			Result.set_with_named_file ("../resources/images/attribute.png")
		end

	routine_pixmap: EV_PIXMAP
		once ("PROCESS")
			create Result
			Result.set_with_named_file ("../resources/images/routine.png")
		end

end
